import { Message } from '../core/type';

export interface Codec {
  encode(message: string): Message;
  decode(message: Message): string;
}

export class DefaultCodec implements Codec {
  public encode(message: string): Message {
    return message;
  }
  public decode(message: Message): string {
    return message as string;
  }
}

export const defaultCodec = new DefaultCodec();

export interface CodecSelector {
  encode(message: string): Message;
  decode(message: Message): string;
}

export class DefaultCodecSelector implements CodecSelector {
  public encode(message: string): Message {
    return defaultCodec.encode(message);
  }
  public decode(message: Message): string {
    return defaultCodec.decode(message);
  }
}

export const defaultCodecSelector = new DefaultCodecSelector();
