import { Message } from '../core/type';
import { RPCError } from './error';
import { RegistryCodec } from './registry_codec';

export interface ClientCodec {
  request(method: string, args: any[] | null, id: number): Message;
  response(res: Message): ClientResponseCodec;
}

export interface ClientResponseCodec {
  id(): number | undefined;
  error(): RPCError | undefined;
  result(): any | undefined;

  isNotification(): boolean;
  notification(): ClientNotificationCodec | undefined;
}

export interface ClientNotificationCodec extends RegistryCodec { }
