export function convertParamsToStringArray(args: any[] | null): string[] {
  const values: string[] = [];

  if (null === args || 0 === args.length) {
    return values;
  }

  for (let indexI = 0; indexI < args.length; indexI++) {
    const arg = args[indexI];

    switch (typeof arg) {
      case 'boolean':
      case 'number': // enum
        values.push(String(arg));
        break;
      case 'string':
        values.push(arg);
        break;
      case 'object':  // array, map
        values.push(JSON.stringify(arg));
        break;
      default:
        throw new Error(`Not supported type[${typeof arg}]`);
    }
  }

  return values;
}
